"""inital tables

Peek Plugin Database Migration Script

Revision ID: f9631012ab4b
Revises: 
Create Date: 2018-10-14 11:17:46.695687

"""

# revision identifiers, used by Alembic.
revision = 'f9631012ab4b'
down_revision = None
branch_labels = None
depends_on = None

from alembic import op
import sqlalchemy as sa
import geoalchemy2


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('ModelSet',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('key', sa.String(), nullable=False),
    sa.Column('name', sa.String(), nullable=False),
    sa.Column('comment', sa.String(), nullable=True),
    sa.Column('propsJson', sa.String(), nullable=True),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('key'),
    sa.UniqueConstraint('name'),
    schema='pl_index_blueprint'
    )
    op.create_table('ThingIndexCompilerQueue',
    sa.Column('id', sa.Integer(), nullable=False, autoincrement=True),
    sa.Column('modelSetId', sa.Integer(), nullable=False),
    sa.Column('chunkKey', sa.String(), nullable=False),
    sa.ForeignKeyConstraint(['modelSetId'], ['pl_index_blueprint.ModelSet.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('id', 'chunkKey'),
    schema='pl_index_blueprint'
    )
    op.create_table('ThingIndexEncodedChunk',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('modelSetId', sa.Integer(), nullable=False),
    sa.Column('chunkKey', sa.String(), nullable=False),
    sa.Column('encodedData', sa.LargeBinary(), nullable=False),
    sa.Column('encodedHash', sa.String(), nullable=False),
    sa.Column('lastUpdate', sa.String(), nullable=False),
    sa.ForeignKeyConstraint(['modelSetId'], ['pl_index_blueprint.ModelSet.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('id'),
    schema='pl_index_blueprint'
    )
    op.create_index('idx_Chunk_modelSetId_chunkKey', 'ThingIndexEncodedChunk', ['modelSetId', 'chunkKey'], unique=False, schema='pl_index_blueprint')
    op.create_table('ThingType',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('modelSetId', sa.Integer(), nullable=False),
    sa.Column('key', sa.String(), nullable=False),
    sa.Column('name', sa.String(), nullable=False),
    sa.ForeignKeyConstraint(['modelSetId'], ['pl_index_blueprint.ModelSet.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('id'),
    schema='pl_index_blueprint'
    )
    op.create_index('idx_DocType_model_key', 'ThingType', ['modelSetId', 'key'], unique=True, schema='pl_index_blueprint')
    op.create_index('idx_DocType_model_name', 'ThingType', ['modelSetId', 'name'], unique=True, schema='pl_index_blueprint')
    op.create_table('ThingIndex',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('modelSetId', sa.Integer(), nullable=False),
    sa.Column('thingTypeId', sa.Integer(), nullable=False),
    sa.Column('importGroupHash', sa.String(), nullable=False),
    sa.Column('key', sa.String(), nullable=False),
    sa.Column('chunkKey', sa.String(), nullable=False),
    sa.Column('packedJson', sa.String(), nullable=False),
    sa.ForeignKeyConstraint(['modelSetId'], ['pl_index_blueprint.ModelSet.id'], ondelete='CASCADE'),
    sa.ForeignKeyConstraint(['thingTypeId'], ['pl_index_blueprint.ThingType.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('id'),
    schema='pl_index_blueprint'
    )
    op.create_index('idx_key_index_gridKey', 'ThingIndex', ['chunkKey'], unique=False, schema='pl_index_blueprint')
    op.create_index('idx_key_index_importGroupHash', 'ThingIndex', ['importGroupHash'], unique=False, schema='pl_index_blueprint')
    op.create_index('idx_key_index_key', 'ThingIndex', ['modelSetId', 'key'], unique=True, schema='pl_index_blueprint')
    op.create_index('idx_key_index_thingType', 'ThingIndex', ['thingTypeId'], unique=False, schema='pl_index_blueprint')
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index('idx_key_index_thingType', table_name='ThingIndex', schema='pl_index_blueprint')
    op.drop_index('idx_key_index_key', table_name='ThingIndex', schema='pl_index_blueprint')
    op.drop_index('idx_key_index_importGroupHash', table_name='ThingIndex', schema='pl_index_blueprint')
    op.drop_index('idx_key_index_gridKey', table_name='ThingIndex', schema='pl_index_blueprint')
    op.drop_table('ThingIndex', schema='pl_index_blueprint')
    op.drop_index('idx_DocType_model_name', table_name='ThingType', schema='pl_index_blueprint')
    op.drop_index('idx_DocType_model_key', table_name='ThingType', schema='pl_index_blueprint')
    op.drop_table('ThingType', schema='pl_index_blueprint')
    op.drop_index('idx_Chunk_modelSetId_chunkKey', table_name='ThingIndexEncodedChunk', schema='pl_index_blueprint')
    op.drop_table('ThingIndexEncodedChunk', schema='pl_index_blueprint')
    op.drop_table('ThingIndexCompilerQueue', schema='pl_index_blueprint')
    op.drop_table('ModelSet', schema='pl_index_blueprint')
    # ### end Alembic commands ###